
typedef GtkWidget *(*GDoDemoFunc) (GtkWidget *do_widget);

typedef struct _Demo Demo;

struct _Demo
{
  const char *name;
  const char *title;
  const char *filename;
  GDoDemoFunc func;
  Demo *children;
};

GtkWidget *do_application_demo (GtkWidget *do_widget);
GtkWidget *do_assistant (GtkWidget *do_widget);
GtkWidget *do_builder (GtkWidget *do_widget);
GtkWidget *do_clipboard (GtkWidget *do_widget);
GtkWidget *do_colorsel (GtkWidget *do_widget);
GtkWidget *do_combobox (GtkWidget *do_widget);
GtkWidget *do_constraints (GtkWidget *do_widget);
GtkWidget *do_constraints2 (GtkWidget *do_widget);
GtkWidget *do_constraints3 (GtkWidget *do_widget);
GtkWidget *do_css_accordion (GtkWidget *do_widget);
GtkWidget *do_css_basics (GtkWidget *do_widget);
GtkWidget *do_css_blendmodes (GtkWidget *do_widget);
GtkWidget *do_css_multiplebgs (GtkWidget *do_widget);
GtkWidget *do_css_pixbufs (GtkWidget *do_widget);
GtkWidget *do_css_shadows (GtkWidget *do_widget);
GtkWidget *do_cursors (GtkWidget *do_widget);
GtkWidget *do_dialog (GtkWidget *do_widget);
GtkWidget *do_drawingarea (GtkWidget *do_widget);
GtkWidget *do_dnd (GtkWidget *do_widget);
GtkWidget *do_editable_cells (GtkWidget *do_widget);
GtkWidget *do_entry_completion (GtkWidget *do_widget);
GtkWidget *do_entry_undo (GtkWidget *do_widget);
GtkWidget *do_expander (GtkWidget *do_widget);
GtkWidget *do_filtermodel (GtkWidget *do_widget);
GtkWidget *do_fishbowl (GtkWidget *do_widget);
GtkWidget *do_fixed (GtkWidget *do_widget);
GtkWidget *do_fontrendering (GtkWidget *do_widget);
GtkWidget *do_gestures (GtkWidget *do_widget);
GtkWidget *do_glarea (GtkWidget *do_widget);
GtkWidget *do_headerbar (GtkWidget *do_widget);
GtkWidget *do_hypertext (GtkWidget *do_widget);
GtkWidget *do_iconscroll (GtkWidget *do_widget);
GtkWidget *do_iconview (GtkWidget *do_widget);
GtkWidget *do_iconview_edit (GtkWidget *do_widget);
GtkWidget *do_images (GtkWidget *do_widget);
GtkWidget *do_infobar (GtkWidget *do_widget);
GtkWidget *do_links (GtkWidget *do_widget);
GtkWidget *do_listbox (GtkWidget *do_widget);
GtkWidget *do_flowbox (GtkWidget *do_widget);
GtkWidget *do_list_store (GtkWidget *do_widget);
GtkWidget *do_markup (GtkWidget *do_widget);
GtkWidget *do_modelbutton (GtkWidget *do_widget);
GtkWidget *do_overlay (GtkWidget *do_widget);
GtkWidget *do_overlay2 (GtkWidget *do_widget);
GtkWidget *do_paint (GtkWidget *do_widget);
GtkWidget *do_paintable (GtkWidget *do_widget);
GtkWidget *do_paintable_animated (GtkWidget *do_widget);
GtkWidget *do_paintable_mediastream (GtkWidget *do_widget);
GtkWidget *do_panes (GtkWidget *do_widget);
GtkWidget *do_password_entry (GtkWidget *do_widget);
GtkWidget *do_peg_solitaire (GtkWidget *do_widget);
GtkWidget *do_pickers (GtkWidget *do_widget);
GtkWidget *do_pixbufs (GtkWidget *do_widget);
GtkWidget *do_popover (GtkWidget *do_widget);
GtkWidget *do_printing (GtkWidget *do_widget);
GtkWidget *do_revealer (GtkWidget *do_widget);
GtkWidget *do_rotated_text (GtkWidget *do_widget);
GtkWidget *do_scale (GtkWidget *do_widget);
GtkWidget *do_search_entry (GtkWidget *do_widget);
GtkWidget *do_search_entry2 (GtkWidget *do_widget);
GtkWidget *do_shortcuts (GtkWidget *do_widget);
GtkWidget *do_shortcut_triggers (GtkWidget *do_widget);
GtkWidget *do_sidebar (GtkWidget *do_widget);
GtkWidget *do_sizegroup (GtkWidget *do_widget);
GtkWidget *do_sliding_puzzle (GtkWidget *do_widget);
GtkWidget *do_spinbutton (GtkWidget *do_widget);
GtkWidget *do_spinner (GtkWidget *do_widget);
GtkWidget *do_stack (GtkWidget *do_widget);
GtkWidget *do_tabs (GtkWidget *do_widget);
GtkWidget *do_tagged_entry (GtkWidget *do_widget);
GtkWidget *do_textmask (GtkWidget *do_widget);
GtkWidget *do_textundo (GtkWidget *do_widget);
GtkWidget *do_textview (GtkWidget *do_widget);
GtkWidget *do_textscroll (GtkWidget *do_widget);
GtkWidget *do_themes (GtkWidget *do_widget);
GtkWidget *do_theming_style_classes (GtkWidget *do_widget);
GtkWidget *do_transparent (GtkWidget *do_widget);
GtkWidget *do_tree_store (GtkWidget *do_widget);
GtkWidget *do_video_player (GtkWidget *do_widget);
GtkWidget *do_font_features (GtkWidget *do_widget);
GtkWidget *do_pagesetup (GtkWidget *do_widget);

Demo child0[] = {
  { "constraints", "Simple", "constraints.c", do_constraints, NULL },
  { "constraints2", "Interactive", "constraints2.c", do_constraints2, NULL },
  { "constraints3", "VFL", "constraints3.c", do_constraints3, NULL },
  { NULL }
};

Demo child3[] = {
  { "css_accordion", "CSS Accordion", "css_accordion.c", do_css_accordion, NULL },
  { "css_basics", "CSS Basics", "css_basics.c", do_css_basics, NULL },
  { "css_blendmodes", "CSS Blend Modes", "css_blendmodes.c", do_css_blendmodes, NULL },
  { "css_multiplebgs", "Multiple Backgrounds", "css_multiplebgs.c", do_css_multiplebgs, NULL },
  { "css_pixbufs", "Animated Backgrounds", "css_pixbufs.c", do_css_pixbufs, NULL },
  { "css_shadows", "Shadows", "css_shadows.c", do_css_shadows, NULL },
  { "theming_style_classes", "Style Classes", "theming_style_classes.c", do_theming_style_classes, NULL },
  { NULL }
};

Demo child9[] = {
  { "editable_cells", "Editable Cells", "editable_cells.c", do_editable_cells, NULL },
  { "filtermodel", "Filter Model", "filtermodel.c", do_filtermodel, NULL },
  { "list_store", "List Store", "list_store.c", do_list_store, NULL },
  { "tree_store", "Tree Store", "tree_store.c", do_tree_store, NULL },
  { NULL }
};

Demo child10[] = {
  { "entry_completion", "Entry Completion", "entry_completion.c", do_entry_completion, NULL },
  { "entry_undo", "Entry Undo", "entry_undo.c", do_entry_undo, NULL },
  { "password_entry", "Password Entry", "password_entry.c", do_password_entry, NULL },
  { "search_entry", "Search Entry", "search_entry.c", do_search_entry, NULL },
  { "search_entry2", "Delayed Search Entry", "search_entry2.c", do_search_entry2, NULL },
  { "tagged_entry", "Tagged Entry", "tagged_entry.c", do_tagged_entry, NULL },
  { NULL }
};

Demo child13[] = {
  { "fishbowl", "Fishbowl", "fishbowl.c", do_fishbowl, NULL },
  { "iconscroll", "Scrolling", "iconscroll.c", do_iconscroll, NULL },
  { "themes", "Themes", "themes.c", do_themes, NULL },
  { NULL }
};

Demo child14[] = {
  { "fontrendering", "Font rendering", "fontrendering.c", do_fontrendering, NULL },
  { "rotated_text", "Rotated Text", "rotated_text.c", do_rotated_text, NULL },
  { "textmask", "Text Mask", "textmask.c", do_textmask, NULL },
  { "font_features", "Font Explorer", "font_features.c", do_font_features, NULL },
  { NULL }
};

Demo child15[] = {
  { "hypertext", "Hypertext", "hypertext.c", do_hypertext, NULL },
  { "markup", "Markup", "markup.c", do_markup, NULL },
  { "tabs", "Tabs", "tabs.c", do_tabs, NULL },
  { "textundo", "Undo and Redo", "textundo.c", do_textundo, NULL },
  { "textview", "Multiple Views", "textview.c", do_textview, NULL },
  { "textscroll", "Automatic Scrolling", "textscroll.c", do_textscroll, NULL },
  { NULL }
};

Demo child17[] = {
  { "iconview", "Icon View Basics", "iconview.c", do_iconview, NULL },
  { "iconview_edit", "Editing and Drag-and-Drop", "iconview_edit.c", do_iconview_edit, NULL },
  { NULL }
};

Demo child21[] = {
  { "overlay", "Interactive Overlay", "overlay.c", do_overlay, NULL },
  { "overlay2", "Decorative Overlay", "overlay2.c", do_overlay2, NULL },
  { "transparent", "Transparency", "transparent.c", do_transparent, NULL },
  { NULL }
};

Demo child23[] = {
  { "paintable", "A simple paintable", "paintable.c", do_paintable, NULL },
  { "paintable_animated", "An animated paintable", "paintable_animated.c", do_paintable_animated, NULL },
  { "paintable_mediastream", "A media stream", "paintable_mediastream.c", do_paintable_mediastream, NULL },
  { NULL }
};

Demo child27[] = {
  { "printing", "Printing", "printing.c", do_printing, NULL },
  { "pagesetup", "Page Setup", "pagesetup.c", do_pagesetup, NULL },
  { NULL }
};

Demo gtk_demos[] = {
  { "application_demo", "Application Class", "application_demo.c", do_application_demo, NULL },
  { "assistant", "Assistant", "assistant.c", do_assistant, NULL },
  { NULL, "Benchmark", NULL, NULL, child13 },
  { "builder", "Builder", "builder.c", do_builder, NULL },
  { "clipboard", "Clipboard", "clipboard.c", do_clipboard, NULL },
  { "colorsel", "Color Chooser", "colorsel.c", do_colorsel, NULL },
  { "combobox", "Combo Boxes", "combobox.c", do_combobox, NULL },
  { NULL, "Constraints", NULL, NULL, child0 },
  { "cursors", "Cursors", "cursors.c", do_cursors, NULL },
  { "dialog", "Dialogs and Message Boxes", "dialog.c", do_dialog, NULL },
  { "dnd", "Drag-and-Drop", "dnd.c", do_dnd, NULL },
  { "drawingarea", "Drawing Area", "drawingarea.c", do_drawingarea, NULL },
  { NULL, "Entry", NULL, NULL, child10 },
  { "expander", "Expander", "expander.c", do_expander, NULL },
  { "fixed", "Fixed layout", "fixed.c", do_fixed, NULL },
  { "flowbox", "Flow Box", "flowbox.c", do_flowbox, NULL },
  { "gestures", "Gestures", "gestures.c", do_gestures, NULL },
  { "headerbar", "Header Bar", "headerbar.c", do_headerbar, NULL },
  { NULL, "Icon View", NULL, NULL, child17 },
  { "images", "Images", "images.c", do_images, NULL },
  { "infobar", "Info Bars", "infobar.c", do_infobar, NULL },
  { "links", "Links", "links.c", do_links, NULL },
  { "listbox", "List Box", "listbox.c", do_listbox, NULL },
  { "modelbutton", "Model Button", "modelbutton.c", do_modelbutton, NULL },
  { "glarea", "OpenGL Area", "glarea.c", do_glarea, NULL },
  { NULL, "Overlay", NULL, NULL, child21 },
  { "paint", "Paint", "paint.c", do_paint, NULL },
  { NULL, "Paintable", NULL, NULL, child23 },
  { "panes", "Paned Widgets", "panes.c", do_panes, NULL },
  { NULL, "Pango", NULL, NULL, child14 },
  { "peg_solitaire", "Peg Solitaire", "peg_solitaire.c", do_peg_solitaire, NULL },
  { "pickers", "Pickers", "pickers.c", do_pickers, NULL },
  { "pixbufs", "Pixbufs", "pixbufs.c", do_pixbufs, NULL },
  { "popover", "Popovers", "popover.c", do_popover, NULL },
  { NULL, "Printing", NULL, NULL, child27 },
  { "revealer", "Revealer", "revealer.c", do_revealer, NULL },
  { "scale", "Scale", "scale.c", do_scale, NULL },
  { "shortcut_triggers", "Shortcuts", "shortcut_triggers.c", do_shortcut_triggers, NULL },
  { "shortcuts", "Shortcuts Window", "shortcuts.c", do_shortcuts, NULL },
  { "sizegroup", "Size Groups", "sizegroup.c", do_sizegroup, NULL },
  { "sliding_puzzle", "Sliding puzzle", "sliding_puzzle.c", do_sliding_puzzle, NULL },
  { "spinbutton", "Spin Button", "spinbutton.c", do_spinbutton, NULL },
  { "spinner", "Spinner", "spinner.c", do_spinner, NULL },
  { "stack", "Stack", "stack.c", do_stack, NULL },
  { "sidebar", "Stack Sidebar", "sidebar.c", do_sidebar, NULL },
  { NULL, "Text View", NULL, NULL, child15 },
  { NULL, "Theming", NULL, NULL, child3 },
  { NULL, "Tree View", NULL, NULL, child9 },
  { "video_player", "Video Player", "video_player.c", do_video_player, NULL },
  { NULL }
};
